#include "globals.h"
#include <SPI.h>
#include <SdFat.h>  // One SD library to rule them all - Greinman SdFat from Library Manager

SdFatEX SD;

#define SDINIT 4     // SD_CS pin D4
#define LED 13       // internal LED lin D13
#define BUZZERPIN 8  // ##### added - buzzer pin D8
#define CONSPIN 3    // ##### added - console switch pin D3
#define RESETPIN 2   // ##### added - reset pin D2
#define DELAY 100    // Delay for LED blinking
#define BOARD "ARDUINO DUE"

#include "DueTimer.h"      // ##### added
#include "TimerFreeTone.h" // ##### added
#include "Wire.h"          // ##### added
#include "abstraction_arduino.h"
#include "ansiprint.h"     // ##### added
#include "console.h"
#include "cpu.h"
#include "disk.h"
#include "ds3231.h"        // ##### added
#include "cpm.h"
#include "zcpr.h"          // ##### added

void setup()
{
	SdFile::dateTimeCallback(dateTime); // ##### added
	Wire.begin();                       // ##### added
	set_HW();                           // ##### added
	header();
	if (!SD.begin(SDINIT, SD_SCK_MHZ(25))) {  // ##### adapted
		_puts("Unable to initialize SD card.\r\n");
		halt();
	}
	_init_zcpr3();                    // ##### added
	_PatchBIOS();                     // ##### added
}

void loop()
{
	_PatchCPM();
	_puts(CCPHEAD);
	if (!_RamLoad((char *)CCPname, CCPaddr)) {
		_puts("Unable to load CCP.\r\n");
		halt();
	}
	Z80reset();
	SET_LOW_REGISTER(BC, _RamRead(DUbyte));
	PC = CCPaddr;
	Z80run();
	if (Status == 1) {
		hw_Reset();  // ##### added
		// halt();
	}
}

