#ifndef CONSOLE_H
#define CONSOLE_H

uint8 mask8bit = 0x7f;		// TO be used for masking 8 bit characters (XMODEM related)


// Put a character to console
void _putcon(uint8 ch)
{
	if (printJob) {
		insBuf(ch & mask8bit);
	} else {
		_putch(ch & mask8bit);
	}
}


// Put a null terminated string
void _puts(const char* str)
{
	while (*str)
		_putcon(*(str++));
}


// Put a HH hex string
void _puthex8(uint8 c)
{
	_putcon(tohex(c >> 4));
	_putcon(tohex(c & 0x0f));
}


// Put a HHHH hex string
void _puthex16(uint16 w)
{
	_puthex8(w >> 8);
	_puthex8(w & 0x00ff);
}


// Put a greeting header
void header()
{
	_putch(12); // ##### changed
	_puts("CP/M 2.2 Emulator v" VERSION " by Marcelo Dantas\r\n");
	_puts("      Build " __DATE__ " - " __TIME__ "\r\n");
	_puts("--------------------------------------------\r\n");
	_puts("CCP: " CCPname "    CCP Address: 0x");
	_puthex16(CCPaddr);
	_puts("\r\nBOARD: " BOARD "\r\n");
	_puts("\r\n");
}

#endif
