// RunCPM extensions
// ZCPR 3.3 implementation

#ifndef ZCPR_H
#define ZCPR_H
#define TPAADR (TPASIZE * 1024) // 0xf000 for RunCMP 60K
#define WORKADR 0xc000


void _init_zcpr3()
{
	_puts("Initializing ZCPR33 buffers.\r\n");
	// Set all memory for buffers to zero
	_RamFill(TPAADR, MEMSIZE - TPAADR, 0);
	// Init of Environment Descriptor
	_RamLoad((char *)"A/0/SYS.ENV", WORKADR);
	_RamCopy(WORKADR, 256, _RamRead16(WORKADR + 27)); // 27 = offset for Z3ENV
	// Init of Resident Command Package
	uint16 dest = _RamRead16(WORKADR + 12); // 12 = offset for RCP
	if (dest) {
		_RamLoad((char *)"A/0/SYS.RCP", dest);
	}
	// Init of Flow Command Package
	dest = _RamRead16(WORKADR + 18); // 18 = offset for FCP
	if (dest) {
		_RamLoad((char *)"A/0/SYS.FCP", dest);
	}
	// Init of Named Directory Buffer
	dest = _RamRead16(WORKADR + 21); // 21 = offset for Z3NDIRS
	if (dest) {
		_RamLoad((char *)"A/0/SYS.NDR", dest);
	}
	// Init of Command Line Buffer
	_RamLoad((char *)"A/0/SYS.MCL", _RamRead16(WORKADR + 24)); // 24 = offset for Z3CL
	// Init of Wheel Byte
	_RamWrite(_RamRead16(WORKADR + 41), 255); // 41 = ofset for Z3WHL
}

#endif

